// CClient.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "CClient.h"
#include <netlayer.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;	

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.
		CString strHello;
		strHello.LoadString(IDS_HELLO);
		Ice::CommunicatorPtr communicator;
		NetLayer::CameraClientPrx proxy;
		try
		{
			//int argc = 0;
			Ice::InitializationData initData;
			initData.properties = Ice::createProperties();
			initData.properties->load("client.config");		
			communicator = Ice::initialize(argc, argv, initData);
			Ice::ObjectPrx obj = communicator->propertyToProxy("CameraService.Proxy");			
			proxy = NetLayer::CameraClientPrx::uncheckedCast(obj);						
			bool ret = proxy->CheckRights(1,1,1,1);			
			cout<<"\nCheckRights return "<<ret<<endl;
			::NetLayer::UserInfo user;
			ret = proxy->Login("jans","ok",user);			
			cout<<"\nLogin  return "<<ret<<endl;			
			::NetLayer::DeviceInfo dev;
			ret = proxy->GetDeviceById(1,1,dev);
			cout<<"\nGetDeviceById  return "<<ret<<endl;
			::NetLayer::DeviceSeq devs;
			ret = proxy->GetDevicesByParentId(1,1,devs);
			cout<<"\ncall GetDevicesByParentId  return "<<ret<<endl;
			

		}
		catch(const IceUtil::Exception& ex)
		{
			ostringstream ostr;
			ostr << ex;
			string s = ostr.str();
			cerr<<s;
			return FALSE;
		}
		catch(const char * msg) {
			cerr << msg << endl;			
		}
		communicator->destroy();
		cout << "communicator shuting..." << endl;
	}

	return nRetCode;
	return nRetCode;
}


