// CServer.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "CServer.h"
#include "CameraClientI.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;


int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.
		CString strHello;
		strHello.LoadString(IDS_HELLO);
		cout<<(LPCTSTR)strHello<<endl;
		Ice::CommunicatorPtr communicator;
		Ice::ObjectAdapterPtr adapter;
		try
		{
			//int argc = 0;
			Ice::InitializationData initData;
			initData.properties = Ice::createProperties();
			initData.properties->load("server.config");		
			communicator = Ice::initialize(argc, argv, initData);
			adapter = communicator->createObjectAdapter("CameraService.Server");
			CameraClientI* pObj = new CameraClientI;
			Ice::ObjectPtr object = pObj;									
			adapter->add(object,communicator->stringToIdentity("CameraServiceServerIdentify"));
			adapter->activate();
			communicator->waitForShutdown();

		}
		catch(const IceUtil::Exception& ex)
		{
			ostringstream ostr;
			ostr << ex;
			string s = ostr.str();
			cerr<<s;
			return FALSE;
		}
		catch(const char * msg) {
			cerr << msg << endl;			
		}
		communicator->destroy();
		cout << "Server shuting..." << endl;
	}

	return nRetCode;
}


