// Camera.h : Declaration of the CCamera

#ifndef __CAMERA_H_
#define __CAMERA_H_

#include "resource.h"       // main symbols
#include <comdef.h>
/////////////////////////////////////////////////////////////////////////////
// CCamera
class ATL_NO_VTABLE CCamera : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ICamera, &IID_ICamera, &LIBID_SEURITYINFOLib>
{
public:
	CCamera() 
	{
		m_lCameraId = -1;
	}

//DECLARE_REGISTRY_RESOURCEID(IDR_CAMERA)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCamera)
	COM_INTERFACE_ENTRY(ICamera)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()
private:
	long	m_lCameraId;
	CString m_strConnectString;
	CString m_strDescription;
// ICamera
public:
	void SetCameraId(long lId);
	void SetDescription(LPCTSTR lpszDesc);
	void SetConnectString(LPCTSTR lpszConnStr);

public:
// ICamera
	STDMETHOD(get_DeviceId)(/*[out, retval]*/ long *pVal);	
	STDMETHOD(get_ConnectionInfo)(/*[out, retval]*/ BSTR *pVal);	
	STDMETHOD(get_Description)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_CameraId)(/*[out, retval]*/ long *pVal);
};
_COM_SMARTPTR_TYPEDEF(ICamera, __uuidof(ICamera));
#endif //__CAMERA_H_
