// Communicator.cpp : Implementation of CSeurityInfoApp and DLL registration.

#include "stdafx.h"
#include "SeurityInfo.h"
#include "Communicator.h"

/////////////////////////////////////////////////////////////////////////////
//
using namespace std;
bool CCommunicator::Init()
{
	if(m_bInited)
	{
		cout<<"CCommunicator::Init() as already called!"<<endl;
		return true;
	}
	else
		cout<<"CCommunicator::Init() first called!"<<endl;
	try
		{			
			int argc = 1;
			char *argv[] ={"ClientApp"};
			Ice::InitializationData initData;			
						
			initData.properties = Ice::createProperties();
			initData.properties->load("client.config");		
			_communicator = Ice::initialize(argc, argv, initData);
			Ice::ObjectPrx obj = _communicator->propertyToProxy("CameraService.Proxy");			
			_proxy = NetLayer::CameraClientPrx::uncheckedCast(obj);									
 		

 			m_bInited = true;

		}
		catch(const IceUtil::Exception& ex)
		{
			ostringstream ostr;
			ostr << ex;
			string s = ostr.str();
			cerr<<s;			
		}
		catch(const char * msg) {
			cerr << msg << endl;			
		}	
		return true;
}
void CCommunicator::Uninit()
{
	if(!m_bInited)
	{
		cerr<<"has not been inited yet."<<endl;
		return;
	}
try{			
		_communicator->destroy();		
	}
	catch(const IceUtil::Exception& ex)
	{
			ostringstream ostr;
			ostr << ex;
			string s = ostr.str();
			cerr<<s;			
	}
	catch(const char * msg) {
			cerr << msg << endl;			
	}
	catch(...)
	{
		cerr<<"Unknown Exception..."<<endl;
	}
}