// Device.h : Declaration of the CDevice

#ifndef __DEVICE_H_
#define __DEVICE_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CDevice
class ATL_NO_VTABLE CDevice : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDevice, &CLSID_Device>,
	public IDispatchImpl<IDevice, &IID_IDevice, &LIBID_SEURITYINFOLib>
{
public:
	CDevice()
	{
		
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DEVICE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CDevice)
	COM_INTERFACE_ENTRY(IDevice)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

private:
	CString m_strDescription;
	long    m_lDeviceId;
public:
	void SetDescription(LPCTSTR lpszDesc) {m_strDescription = lpszDesc;}
public:
// IDevice
	STDMETHOD(get_Description)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_Cameras)(/*[out, retval]*/ ISet **pVal);
	STDMETHOD(get_DeviceId)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_DeviceId)(/*[in]*/ long newVal);
};

#endif //__DEVICE_H_
