// SeurityInfo.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f SeurityInfops.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "SeurityInfo.h"

#include "SeurityInfo_i.c"
#include "User.h"
#include "Camera.h"
#include "Device.h"
#include "Set.h"
#include "DeviceFactory.h"
#include "Communicator.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_User, CUser)
//OBJECT_ENTRY(CLSID_Camera, CCamera)
OBJECT_ENTRY(CLSID_Device, CDevice)
OBJECT_ENTRY(CLSID_Set, CSet)
OBJECT_ENTRY(CLSID_DeviceFactory, CDeviceFactory)
OBJECT_ENTRY(CLSID_Communicator, CCommunicator)
END_OBJECT_MAP()

class CSeurityInfoApp : public CWinApp
{
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSeurityInfoApp)
	public:
    virtual BOOL InitInstance();
    virtual int ExitInstance();	
	//}}AFX_VIRTUAL	
	//{{AFX_MSG(CSeurityInfoApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

BEGIN_MESSAGE_MAP(CSeurityInfoApp, CWinApp)
	//{{AFX_MSG_MAP(CSeurityInfoApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CSeurityInfoApp theApp;
CComObject<CCommunicator>* g_pComm =NULL;
using namespace std;
BOOL CSeurityInfoApp::InitInstance()
{    
	//m_myThread.InitStartWork(&m_ice_app);
	_Module.Init(ObjectMap, m_hInstance, &LIBID_SEURITYINFOLib);		

	HRESULT hr;
	hr=CComObject<CCommunicator>::CreateInstance(&g_pComm);
	g_pComm->Init();
	if(FAILED(hr)){
		printf("\nError Create communicator!");
		return -1;
	}

    return CWinApp::InitInstance();
}

int CSeurityInfoApp::ExitInstance()
{		
	cout<<"Exit...."<<endl;	
	if(g_pComm)
			g_pComm->Uninit();
	

	
	_Module.Term();
	//CCommunicator::communicator()->shutdown();	
// 	if(m_myThread.GetThreadStatus())
// 	{		
// 		printf("\nshuting down ice...\n");
// 		if(m_myThread.StopThread())
// 		{
// 			printf(_T("ICE Thread killed successfuly!"));						
// 		}
// 		else
// 			printf(_T("Could not abort ICE thread!"));								
// 	}
   
    return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return (AfxDllCanUnloadNow()==S_OK && _Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}



