// User.h : Declaration of the CUser

#ifndef __USER_H_
#define __USER_H_

#include "resource.h"       // main symbols
#include "SeurityInfoCP.h"

/////////////////////////////////////////////////////////////////////////////
// CUser
class ATL_NO_VTABLE CUser : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CUser, &CLSID_User>,
	public IConnectionPointContainerImpl<CUser>,
	public IDispatchImpl<IUser, &IID_IUser, &LIBID_SEURITYINFOLib>,
	public CProxy_IUserEvents< CUser >,
	public IPersistImpl<CUser>
{
public:
	CUser()
	{	
		m_IsLogin = VARIANT_FALSE;
		m_lUserId = -1;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_USER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CUser)
	COM_INTERFACE_ENTRY(IUser)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IPersist)	
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CUser)
CONNECTION_POINT_ENTRY(DIID__IUserEvents)
END_CONNECTION_POINT_MAP()

private:
	VARIANT_BOOL m_IsLogin;
	CString m_strUserName;
	long m_lUserId;
// IUser
public:
	STDMETHOD(EAILogin)(/*[in]*/BSTR userName,/*[in]*/BSTR password,BSTR syscode,/*[out, retval]*/VARIANT_BOOL *bAuthorized);
	STDMETHOD(Login)(BSTR userName, BSTR password,VARIANT_BOOL *bAuthorized);
	STDMETHOD(IsLogin)(VARIANT_BOOL *bLogin);
	STDMETHOD(GetUserName)(BSTR *UserName);
	STDMETHOD(CheckRights)(long DeviceID, long DeviceType, long OperationId,VARIANT_BOOL *bAuthorized);
};

#endif //__USER_H_
