// SecurityInfo.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <stdio.h>



BOOL Test_IDevice()
{
	USES_CONVERSION;
	printf("\n\nTest IDevice Interface....");
	IDevicePtr ipDevice(CLSID_Device);
	ISetPtr ipSet=0; 
	if(FAILED(ipDevice->get_Cameras(&ipSet)))
		return FALSE;
	
	long lCount;
	ipSet->get_Count(&lCount);
	printf("\nget_Cameras count= %d",lCount);
	
	IDispatchPtr ipDisp;
	
	for(int i=0;i<lCount;i++)	
	{
		ipSet->get_Item(i+1,&ipDisp); //1-based index
		ICameraPtr ipCame = (ICameraPtr)ipDisp;

		//ASSERT(ipCame!=NULL);
			
		
		long lCameraId;
		if(FAILED(ipCame->get_CameraId(&lCameraId)))
		return FALSE;
		
		printf("\nget_lCameraId%d",lCameraId);
		CComBSTR var;
		
		if(FAILED(ipCame->get_Description(&var)))
		return FALSE;

		printf("\nget_Description%s",W2T(var));
		

		if(FAILED(ipCame->get_ConnectionInfo(&var)))
			return FALSE;
		
		printf("\nget_ConnectionInfo%s",W2T(var));		
	}
	return TRUE;
}

BOOL Test_IUser()
{
	printf("\n\nTest IUser Interface....");
	USES_CONVERSION;
	IUserPtr ipUser(CLSID_User);
	
	


	VARIANT_BOOL bRet;
	if(FAILED(ipUser->Login(L"admin",L"12345",&bRet)))
		return FALSE;
	printf("\n Login(admin,12345) ¼ %s",bRet ? "successful":"failed");
	if(FAILED(ipUser->IsLogin(&bRet)))
		return FALSE;
	printf("\n IsLogin ¼״̬ %s",bRet ? "successful":"failed");

	if(FAILED(ipUser->Login(L"test",L"88888",&bRet)))
		return FALSE;
	printf("\n Login(test,88888) ¼ %s",bRet ? "successful":"failed");

	if(FAILED(ipUser->CheckRights(101,1,1,&bRet)))
		return FALSE;
	printf("\n CheckRights(101,1,1) Ȩ %s",bRet ? "successful":"failed");

	CComBSTR bstrUserName;
	if(FAILED(ipUser->GetUserName(&bstrUserName)))
		return FALSE;
	
	printf("\n GetUserName û %s",W2T(bstrUserName));
	
	return TRUE;
}

BOOL Test_IDeviceFactory()
{
	printf("\n\nTest IDeviceFactory Interface....");
	IDeviceFactoryPtr ipDeviceFactory(CLSID_DeviceFactory);
	IDispatchPtr ipDevice;
	HRESULT hr = ipDeviceFactory->CreateDevice(1,1,&ipDevice);
	if(FAILED(hr)) return FALSE;
	CComBSTR description;	
	if(FAILED(((IDevicePtr)ipDevice)->get_Description(&description)))
		return FALSE;
	USES_CONVERSION;
	printf("\nȡ%s",W2T(description));
	return TRUE;

}


int main(int argc, char* argv[])
{
	CoInitialize(NULL);

	try
	{
		printf("...%s\n",Test_IDevice()? "successful!":"fail");	
		//printf("...%s\n",Test_IUser()? "successful!":"failed!");	
		//printf("...%s\n",Test_IUser()? "successful!":"failed!");	
		//printf("...%s\n",Test_IDeviceFactory()? "successful!":"failed!");			
	}
	catch(_com_error &e)
	{
		printf("쳣:%s",e.ErrorMessage());
	}
	
	CoUninitialize();
	return 0;

}


