// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.0
// Generated from file `netlayer.ice'

#include <netlayer.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __NetLayer__CameraClient__CheckRights_name = "CheckRights";

static const ::std::string __NetLayer__CameraClient__Login_name = "Login";

static const ::std::string __NetLayer__CameraClient__GetDeviceById_name = "GetDeviceById";

static const ::std::string __NetLayer__CameraClient__GetDevicesByParentId_name = "GetDevicesByParentId";

void
IceInternal::incRef(::NetLayer::CameraClient* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::NetLayer::CameraClient* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::NetLayer::CameraClient* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::NetLayer::CameraClient* p)
{
    p->__decRef();
}

void
NetLayer::__write(::IceInternal::BasicStream* __os, const ::NetLayer::CameraClientPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
NetLayer::__read(::IceInternal::BasicStream* __is, ::NetLayer::CameraClientPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::NetLayer::CameraClient;
        v->__copyFrom(proxy);
    }
}

void
NetLayer::__write(::IceInternal::BasicStream* __os, const ::NetLayer::CameraClientPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

bool
NetLayer::UserInfo::operator==(const UserInfo& __rhs) const
{
    return !operator!=(__rhs);
}

bool
NetLayer::UserInfo::operator!=(const UserInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(userid != __rhs.userid)
    {
        return true;
    }
    if(username != __rhs.username)
    {
        return true;
    }
    if(userdes != __rhs.userdes)
    {
        return true;
    }
    return false;
}

bool
NetLayer::UserInfo::operator<(const UserInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(userid < __rhs.userid)
    {
        return true;
    }
    else if(__rhs.userid < userid)
    {
        return false;
    }
    if(username < __rhs.username)
    {
        return true;
    }
    else if(__rhs.username < username)
    {
        return false;
    }
    if(userdes < __rhs.userdes)
    {
        return true;
    }
    else if(__rhs.userdes < userdes)
    {
        return false;
    }
    return false;
}

void
NetLayer::UserInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(userid);
    __os->write(username);
    __os->write(userdes);
}

void
NetLayer::UserInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(userid);
    __is->read(username);
    __is->read(userdes);
}

bool
NetLayer::DeviceInfo::operator==(const DeviceInfo& __rhs) const
{
    return !operator!=(__rhs);
}

bool
NetLayer::DeviceInfo::operator!=(const DeviceInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(devid != __rhs.devid)
    {
        return true;
    }
    if(devtype != __rhs.devtype)
    {
        return true;
    }
    if(parentdevid != __rhs.parentdevid)
    {
        return true;
    }
    if(des != __rhs.des)
    {
        return true;
    }
    if(name != __rhs.name)
    {
        return true;
    }
    if(url != __rhs.url)
    {
        return true;
    }
    return false;
}

bool
NetLayer::DeviceInfo::operator<(const DeviceInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(devid < __rhs.devid)
    {
        return true;
    }
    else if(__rhs.devid < devid)
    {
        return false;
    }
    if(devtype < __rhs.devtype)
    {
        return true;
    }
    else if(__rhs.devtype < devtype)
    {
        return false;
    }
    if(parentdevid < __rhs.parentdevid)
    {
        return true;
    }
    else if(__rhs.parentdevid < parentdevid)
    {
        return false;
    }
    if(des < __rhs.des)
    {
        return true;
    }
    else if(__rhs.des < des)
    {
        return false;
    }
    if(name < __rhs.name)
    {
        return true;
    }
    else if(__rhs.name < name)
    {
        return false;
    }
    if(url < __rhs.url)
    {
        return true;
    }
    else if(__rhs.url < url)
    {
        return false;
    }
    return false;
}

void
NetLayer::DeviceInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(devid);
    __os->write(devtype);
    __os->write(parentdevid);
    __os->write(des);
    __os->write(name);
    __os->write(url);
}

void
NetLayer::DeviceInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(devid);
    __is->read(devtype);
    __is->read(parentdevid);
    __is->read(des);
    __is->read(name);
    __is->read(url);
}

void
NetLayer::__write(::IceInternal::BasicStream* __os, const ::NetLayer::DeviceInfo* begin, const ::NetLayer::DeviceInfo* end, ::NetLayer::__U__DeviceSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
NetLayer::__read(::IceInternal::BasicStream* __is, ::NetLayer::DeviceSeq& v, ::NetLayer::__U__DeviceSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 15);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
NetLayer::__addObject(const CameraClientPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
NetLayer::__usesClasses(const CameraClientPtr& p)
{
    return p->__usesClasses();
}

void
NetLayer::__decRefUnsafe(const CameraClientPtr& p)
{
    p->__decRefUnsafe();
}

void
NetLayer::__clearHandleUnsafe(CameraClientPtr& p)
{
    p.__clearHandleUnsafe();
}

bool
IceProxy::NetLayer::CameraClient::CheckRights(::Ice::Int userid, ::Ice::Int devid, ::Ice::Int devtype, ::Ice::Int opid, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__NetLayer__CameraClient__CheckRights_name);
            __delBase = __getDelegate();
            ::IceDelegate::NetLayer::CameraClient* __del = dynamic_cast< ::IceDelegate::NetLayer::CameraClient*>(__delBase.get());
            return __del->CheckRights(userid, devid, devtype, opid, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

bool
IceProxy::NetLayer::CameraClient::Login(const ::std::string& username, const ::std::string& password, ::NetLayer::UserInfo& user, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__NetLayer__CameraClient__Login_name);
            __delBase = __getDelegate();
            ::IceDelegate::NetLayer::CameraClient* __del = dynamic_cast< ::IceDelegate::NetLayer::CameraClient*>(__delBase.get());
            return __del->Login(username, password, user, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

bool
IceProxy::NetLayer::CameraClient::GetDeviceById(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceInfo& info, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__NetLayer__CameraClient__GetDeviceById_name);
            __delBase = __getDelegate();
            ::IceDelegate::NetLayer::CameraClient* __del = dynamic_cast< ::IceDelegate::NetLayer::CameraClient*>(__delBase.get());
            return __del->GetDeviceById(devid, devtype, info, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

bool
IceProxy::NetLayer::CameraClient::GetDevicesByParentId(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceSeq& devs, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__NetLayer__CameraClient__GetDevicesByParentId_name);
            __delBase = __getDelegate();
            ::IceDelegate::NetLayer::CameraClient* __del = dynamic_cast< ::IceDelegate::NetLayer::CameraClient*>(__delBase.get());
            return __del->GetDevicesByParentId(devid, devtype, devs, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::NetLayer::CameraClient::ice_staticId()
{
    return ::NetLayer::CameraClient::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::NetLayer::CameraClient::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::NetLayer::CameraClient);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::NetLayer::CameraClient::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::NetLayer::CameraClient);
}

bool
IceProxy::NetLayer::operator==(const ::IceProxy::NetLayer::CameraClient& l, const ::IceProxy::NetLayer::CameraClient& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::NetLayer::operator!=(const ::IceProxy::NetLayer::CameraClient& l, const ::IceProxy::NetLayer::CameraClient& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::NetLayer::operator<(const ::IceProxy::NetLayer::CameraClient& l, const ::IceProxy::NetLayer::CameraClient& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::NetLayer::operator<=(const ::IceProxy::NetLayer::CameraClient& l, const ::IceProxy::NetLayer::CameraClient& r)
{
    return l < r || l == r;
}

bool
IceProxy::NetLayer::operator>(const ::IceProxy::NetLayer::CameraClient& l, const ::IceProxy::NetLayer::CameraClient& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::NetLayer::operator>=(const ::IceProxy::NetLayer::CameraClient& l, const ::IceProxy::NetLayer::CameraClient& r)
{
    return !(l < r);
}

bool
IceDelegateM::NetLayer::CameraClient::CheckRights(::Ice::Int userid, ::Ice::Int devid, ::Ice::Int devtype, ::Ice::Int opid, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __NetLayer__CameraClient__CheckRights_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(userid);
        __os->write(devid);
        __os->write(devtype);
        __os->write(opid);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::NetLayer::CameraClient::Login(const ::std::string& username, const ::std::string& password, ::NetLayer::UserInfo& user, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __NetLayer__CameraClient__Login_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(username);
        __os->write(password);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        user.__read(__is);
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::NetLayer::CameraClient::GetDeviceById(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceInfo& info, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __NetLayer__CameraClient__GetDeviceById_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(devid);
        __os->write(devtype);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        info.__read(__is);
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::NetLayer::CameraClient::GetDevicesByParentId(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceSeq& devs, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __NetLayer__CameraClient__GetDevicesByParentId_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(devid);
        __os->write(devtype);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        ::NetLayer::__read(__is, devs, ::NetLayer::__U__DeviceSeq());
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateD::NetLayer::CameraClient::CheckRights(::Ice::Int userid, ::Ice::Int devid, ::Ice::Int devtype, ::Ice::Int opid, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __NetLayer__CameraClient__CheckRights_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::NetLayer::CameraClient* __servant = dynamic_cast< ::NetLayer::CameraClient*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->CheckRights(userid, devid, devtype, opid, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

bool
IceDelegateD::NetLayer::CameraClient::Login(const ::std::string& username, const ::std::string& password, ::NetLayer::UserInfo& user, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __NetLayer__CameraClient__Login_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::NetLayer::CameraClient* __servant = dynamic_cast< ::NetLayer::CameraClient*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->Login(username, password, user, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

bool
IceDelegateD::NetLayer::CameraClient::GetDeviceById(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceInfo& info, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __NetLayer__CameraClient__GetDeviceById_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::NetLayer::CameraClient* __servant = dynamic_cast< ::NetLayer::CameraClient*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->GetDeviceById(devid, devtype, info, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

bool
IceDelegateD::NetLayer::CameraClient::GetDevicesByParentId(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceSeq& devs, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __NetLayer__CameraClient__GetDevicesByParentId_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::NetLayer::CameraClient* __servant = dynamic_cast< ::NetLayer::CameraClient*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->GetDevicesByParentId(devid, devtype, devs, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPtr
NetLayer::CameraClient::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __NetLayer__CameraClient_ids[2] =
{
    "::Ice::Object",
    "::NetLayer::CameraClient"
};

bool
NetLayer::CameraClient::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__NetLayer__CameraClient_ids, __NetLayer__CameraClient_ids + 2, _s);
}

::std::vector< ::std::string>
NetLayer::CameraClient::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__NetLayer__CameraClient_ids[0], &__NetLayer__CameraClient_ids[2]);
}

const ::std::string&
NetLayer::CameraClient::ice_id(const ::Ice::Current&) const
{
    return __NetLayer__CameraClient_ids[1];
}

const ::std::string&
NetLayer::CameraClient::ice_staticId()
{
    return __NetLayer__CameraClient_ids[1];
}

::IceInternal::DispatchStatus
NetLayer::CameraClient::___CheckRights(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int userid;
    ::Ice::Int devid;
    ::Ice::Int devtype;
    ::Ice::Int opid;
    __is->read(userid);
    __is->read(devid);
    __is->read(devtype);
    __is->read(opid);
    bool __ret = CheckRights(userid, devid, devtype, opid, __current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
NetLayer::CameraClient::___Login(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string username;
    ::std::string password;
    __is->read(username);
    __is->read(password);
    ::NetLayer::UserInfo user;
    bool __ret = Login(username, password, user, __current);
    user.__write(__os);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
NetLayer::CameraClient::___GetDeviceById(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int devid;
    ::Ice::Int devtype;
    __is->read(devid);
    __is->read(devtype);
    ::NetLayer::DeviceInfo info;
    bool __ret = GetDeviceById(devid, devtype, info, __current);
    info.__write(__os);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
NetLayer::CameraClient::___GetDevicesByParentId(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int devid;
    ::Ice::Int devtype;
    __is->read(devid);
    __is->read(devtype);
    ::NetLayer::DeviceSeq devs;
    bool __ret = GetDevicesByParentId(devid, devtype, devs, __current);
    if(devs.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::NetLayer::__write(__os, &devs[0], &devs[0] + devs.size(), ::NetLayer::__U__DeviceSeq());
    }
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

static ::std::string __NetLayer__CameraClient_all[] =
{
    "CheckRights",
    "GetDeviceById",
    "GetDevicesByParentId",
    "Login",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
NetLayer::CameraClient::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__NetLayer__CameraClient_all, __NetLayer__CameraClient_all + 8, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __NetLayer__CameraClient_all)
    {
        case 0:
        {
            return ___CheckRights(in, current);
        }
        case 1:
        {
            return ___GetDeviceById(in, current);
        }
        case 2:
        {
            return ___GetDevicesByParentId(in, current);
        }
        case 3:
        {
            return ___Login(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
NetLayer::CameraClient::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
NetLayer::CameraClient::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
NetLayer::CameraClient::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type NetLayer::CameraClient was not generated with stream support";
    throw ex;
}

void
NetLayer::CameraClient::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type NetLayer::CameraClient was not generated with stream support";
    throw ex;
}

void 
NetLayer::__patch__CameraClientPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::NetLayer::CameraClientPtr* p = static_cast< ::NetLayer::CameraClientPtr*>(__addr);
    assert(p);
    *p = ::NetLayer::CameraClientPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::NetLayer::CameraClient::ice_staticId();
        throw e;
    }
}

bool
NetLayer::operator==(const ::NetLayer::CameraClient& l, const ::NetLayer::CameraClient& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
NetLayer::operator!=(const ::NetLayer::CameraClient& l, const ::NetLayer::CameraClient& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
NetLayer::operator<(const ::NetLayer::CameraClient& l, const ::NetLayer::CameraClient& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
NetLayer::operator<=(const ::NetLayer::CameraClient& l, const ::NetLayer::CameraClient& r)
{
    return l < r || l == r;
}

bool
NetLayer::operator>(const ::NetLayer::CameraClient& l, const ::NetLayer::CameraClient& r)
{
    return !(l < r) && !(l == r);
}

bool
NetLayer::operator>=(const ::NetLayer::CameraClient& l, const ::NetLayer::CameraClient& r)
{
    return !(l < r);
}
