// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.0
// Generated from file `netlayer.ice'

#ifndef __netlayer_h__
#define __netlayer_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/StreamF.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace NetLayer
{

class CameraClient;
bool operator==(const CameraClient&, const CameraClient&);
bool operator!=(const CameraClient&, const CameraClient&);
bool operator<(const CameraClient&, const CameraClient&);
bool operator<=(const CameraClient&, const CameraClient&);
bool operator>(const CameraClient&, const CameraClient&);
bool operator>=(const CameraClient&, const CameraClient&);

}

}

namespace NetLayer
{

class CameraClient;
bool operator==(const CameraClient&, const CameraClient&);
bool operator!=(const CameraClient&, const CameraClient&);
bool operator<(const CameraClient&, const CameraClient&);
bool operator<=(const CameraClient&, const CameraClient&);
bool operator>(const CameraClient&, const CameraClient&);
bool operator>=(const CameraClient&, const CameraClient&);

}

namespace IceInternal
{

void incRef(::NetLayer::CameraClient*);
void decRef(::NetLayer::CameraClient*);

void incRef(::IceProxy::NetLayer::CameraClient*);
void decRef(::IceProxy::NetLayer::CameraClient*);

}

namespace NetLayer
{

typedef ::IceInternal::Handle< ::NetLayer::CameraClient> CameraClientPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::NetLayer::CameraClient> CameraClientPrx;

void __write(::IceInternal::BasicStream*, const CameraClientPrx&);
void __read(::IceInternal::BasicStream*, CameraClientPrx&);
void __write(::IceInternal::BasicStream*, const CameraClientPtr&);
void __patch__CameraClientPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const CameraClientPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const CameraClientPtr&);
void __decRefUnsafe(const CameraClientPtr&);
void __clearHandleUnsafe(CameraClientPtr&);

}

namespace NetLayer
{

struct UserInfo
{
    ::Ice::Int userid;
    ::std::string username;
    ::std::string userdes;

    bool operator==(const UserInfo&) const;
    bool operator!=(const UserInfo&) const;
    bool operator<(const UserInfo&) const;
    bool operator<=(const UserInfo& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const UserInfo& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const UserInfo& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

struct DeviceInfo
{
    ::Ice::Int devid;
    ::Ice::Int devtype;
    ::Ice::Int parentdevid;
    ::std::string des;
    ::std::string name;
    ::std::string url;

    bool operator==(const DeviceInfo&) const;
    bool operator!=(const DeviceInfo&) const;
    bool operator<(const DeviceInfo&) const;
    bool operator<=(const DeviceInfo& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const DeviceInfo& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const DeviceInfo& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::NetLayer::DeviceInfo> DeviceSeq;

class __U__DeviceSeq { };
void __write(::IceInternal::BasicStream*, const ::NetLayer::DeviceInfo*, const ::NetLayer::DeviceInfo*, __U__DeviceSeq);
void __read(::IceInternal::BasicStream*, DeviceSeq&, __U__DeviceSeq);

}

namespace IceProxy
{

namespace NetLayer
{

class CameraClient : virtual public ::IceProxy::Ice::Object
{
public:

    bool CheckRights(::Ice::Int userid, ::Ice::Int devid, ::Ice::Int devtype, ::Ice::Int opid)
    {
        return CheckRights(userid, devid, devtype, opid, 0);
    }
    bool CheckRights(::Ice::Int userid, ::Ice::Int devid, ::Ice::Int devtype, ::Ice::Int opid, const ::Ice::Context& __ctx)
    {
        return CheckRights(userid, devid, devtype, opid, &__ctx);
    }
    
private:

    bool CheckRights(::Ice::Int, ::Ice::Int, ::Ice::Int, ::Ice::Int, const ::Ice::Context*);
    
public:

    bool Login(const ::std::string& username, const ::std::string& password, ::NetLayer::UserInfo& user)
    {
        return Login(username, password, user, 0);
    }
    bool Login(const ::std::string& username, const ::std::string& password, ::NetLayer::UserInfo& user, const ::Ice::Context& __ctx)
    {
        return Login(username, password, user, &__ctx);
    }
    
private:

    bool Login(const ::std::string&, const ::std::string&, ::NetLayer::UserInfo&, const ::Ice::Context*);
    
public:

    bool GetDeviceById(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceInfo& info)
    {
        return GetDeviceById(devid, devtype, info, 0);
    }
    bool GetDeviceById(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceInfo& info, const ::Ice::Context& __ctx)
    {
        return GetDeviceById(devid, devtype, info, &__ctx);
    }
    
private:

    bool GetDeviceById(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceInfo&, const ::Ice::Context*);
    
public:

    bool GetDevicesByParentId(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceSeq& devs)
    {
        return GetDevicesByParentId(devid, devtype, devs, 0);
    }
    bool GetDevicesByParentId(::Ice::Int devid, ::Ice::Int devtype, ::NetLayer::DeviceSeq& devs, const ::Ice::Context& __ctx)
    {
        return GetDevicesByParentId(devid, devtype, devs, &__ctx);
    }
    
private:

    bool GetDevicesByParentId(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceSeq&, const ::Ice::Context*);
    
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace NetLayer
{

class CameraClient : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual bool CheckRights(::Ice::Int, ::Ice::Int, ::Ice::Int, ::Ice::Int, const ::Ice::Context*) = 0;

    virtual bool Login(const ::std::string&, const ::std::string&, ::NetLayer::UserInfo&, const ::Ice::Context*) = 0;

    virtual bool GetDeviceById(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceInfo&, const ::Ice::Context*) = 0;

    virtual bool GetDevicesByParentId(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceSeq&, const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace NetLayer
{

class CameraClient : virtual public ::IceDelegate::NetLayer::CameraClient,
                     virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual bool CheckRights(::Ice::Int, ::Ice::Int, ::Ice::Int, ::Ice::Int, const ::Ice::Context*);

    virtual bool Login(const ::std::string&, const ::std::string&, ::NetLayer::UserInfo&, const ::Ice::Context*);

    virtual bool GetDeviceById(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceInfo&, const ::Ice::Context*);

    virtual bool GetDevicesByParentId(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceSeq&, const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace NetLayer
{

class CameraClient : virtual public ::IceDelegate::NetLayer::CameraClient,
                     virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual bool CheckRights(::Ice::Int, ::Ice::Int, ::Ice::Int, ::Ice::Int, const ::Ice::Context*);

    virtual bool Login(const ::std::string&, const ::std::string&, ::NetLayer::UserInfo&, const ::Ice::Context*);

    virtual bool GetDeviceById(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceInfo&, const ::Ice::Context*);

    virtual bool GetDevicesByParentId(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceSeq&, const ::Ice::Context*);
};

}

}

namespace NetLayer
{

class CameraClient : virtual public ::Ice::Object
{
public:

    typedef CameraClientPrx ProxyType;
    typedef CameraClientPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual bool CheckRights(::Ice::Int, ::Ice::Int, ::Ice::Int, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___CheckRights(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool Login(const ::std::string&, const ::std::string&, ::NetLayer::UserInfo&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___Login(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool GetDeviceById(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceInfo&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetDeviceById(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool GetDevicesByParentId(::Ice::Int, ::Ice::Int, ::NetLayer::DeviceSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetDevicesByParentId(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__CameraClientPtr(void*, ::Ice::ObjectPtr&);

}

#endif
